const { str, expression, findElem, isEvent, prefixSubscription } = require('./util')
const { stateExpression } = require('./state')

const keysWalker = (obj, keys) => {
  for (let key in obj) {
    let field = obj[key]
    if (field && typeof field === 'object') {
      keysWalker(field, keys)
      if (field.$) field._$keysmap_ = keys
    }
  }
}

const JSXAttribute = (node, code, replace) => {
  if (node.type === 'JSXAttribute') {
    const name = node.name.name
    const elem = findElem(node)
    if (node.value) {
      if (node.value.type === 'JSXExpressionContainer') {
        let subscription
        if (!isEvent(name)) {
          if (!node.value.parent) node.value.parent = node
          subscription = stateExpression(node.value, code, replace, elem)
        }
        if (subscription) {
          if (subscription.object) {
            keysWalker(subscription.object, subscription.keys)
            elem._attributes_[name] = subscription.object
          } else {
            elem._attributes_[name] = {
              _$prefix: prefixSubscription(subscription),
              val: subscription.code,
              $: subscription.$object,
              // $: subscription.$multi.length > 1
              //   ? subscription.$object
              //   : subscription.$,
              _$keysmap_: subscription.keys
            }
          }
        } else {
          elem._attributes_[name] = expression(node, code, replace)
        }
      } else if (node.value.type === 'Literal') {
        elem._attributes_[name] = str(node.value.value)
      }
    } else {
      elem._attributes_[name] = true
    }
  }
}

exports.JSXAttribute = JSXAttribute
